Subject: Re: linux-next: build failure after merge of the kspp-gustavo tree

From: "Gustavo A. R. Silva" <[email-masked]>
Date: Wed, 29 Sep 2021 19:11:23 -0500

On Thu, Sep 30, 2021 at 09:59:32AM +1000, Stephen Rothwell wrote:
> Hi all,
> 
> After merging the kspp-gustavo tree, today's linux-next build (x86_64
> allmodconfig) failed like this:
> 
> In file included from include/linux/bpf_verifier.h:9,
>                  from kernel/bpf/verifier.c:12:

[..]

>       |                 ^~~~~~~~~~~~~
> include/linux/filter.h:366:4: error: cast between incompatible function types from 'int (* const)(struct bpf_map *, u32,  u64)' {aka 'int (* const)(struct bpf_map *, unsigned int,  long long unsigned int)'} to 'u64 (*)(u64,  u64,  u64,  u64,  u64)' {aka 'long long unsigned int (*)(long long unsigned int,  long long unsigned int,  long long unsigned int,  long long unsigned int,  long long unsigned int)'} [-Werror=cast-function-type]
>   366 |   ((u64 (*)(u64, u64, u64, u64, u64))(x))
>       |    ^
> kernel/bpf/verifier.c:12977:17: note: in expansion of macro 'BPF_CAST_CALL'
> 12977 |     insn->imm = BPF_CAST_CALL(ops->map_redirect) -
>       |                 ^~~~~~~~~~~~~
> cc1: all warnings being treated as errors

All these are already fixed in bpf-next.

> Caused by commit
> 
>   ffea83dd8823 ("Makefile: Enable -Wcast-function-type")
> 
> I have reverted that commit for today.

I've just removed that commit from my -next tree, while I
take a look at the ftrace warnings.

Thanks!
--
Gustavo